// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('siggo', ['ionic', 'pascalprecht.translate', 'ngCordova', 'ionic-material', 'ngAnimate',
    'ngTouch', 'LocalStorageModule', 'ngError', 'uiGmapgoogle-maps', 'ionic.contrib.drawer',
    'angular-sha1'
  ])

  .run(function($ionicPlatform, $cordovaGoogleAnalytics) {
    $ionicPlatform.ready(function() {
      if (window.cordova && window.cordova.plugins.Keyboard) {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        screen.orientation.lock('portrait');
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

        // Don't remove this line unless you know what you are doing. It stops the viewport
        // from snapping when text inputs are focused. Ionic handles this internally for
        // a much nicer keyboard experience.

        // abilita plugins en segundo plano
        ///////cordova.plugins.backgroundMode.enable();

        cordova.plugins.Keyboard.disableScroll(true);
        ionic.Platform.isFullScreen = true;
      }
      if (window.StatusBar) {
        StatusBar.overlaysWebView(false);
        StatusBar.backgroundColorByHexString("#151515");
        StatusBar.styleLightContent();
        StatusBar.show();
      }

      //GOOGLE ANALYTICS
      if (typeof analytics !== 'undefined') {
        $cordovaGoogleAnalytics.startTrackerWithId('UA-92774552-1');
        //$cordovaGoogleAnalytics.setUserId('my-user-id') when user logs in
      }
    })

  })
  .config(function($stateProvider, $urlRouterProvider, localStorageServiceProvider,
    $ionicConfigProvider, $translateProvider, /*$translatePartialLoaderProvider,*/
    uiGmapGoogleMapApiProvider, configuration) {
    //GOOGLE MAPS


    uiGmapGoogleMapApiProvider.configure({
      key: configuration.apiKey,
      //libraries: 'places',
      preventLoad: false,
      transport: "https"
    });
    //IONIC CONFIG
    $ionicConfigProvider.views.maxCache(10);
    $ionicConfigProvider.views.swipeBackEnabled(false);
    $ionicConfigProvider.platform.ios.views.maxCache(10);
    $ionicConfigProvider.platform.android.views.maxCache(10);
    $ionicConfigProvider.views.transition("ios");
    $ionicConfigProvider.views.forwardCache(true);
    $ionicConfigProvider.form.checkbox("circle");
    //LOCALESTORAGE CONFIG
    localStorageServiceProvider
      .setPrefix('Siggo')
      .setStorageType('localStorage');
    //TRANSLATE CONFIG
    /*	$translatePartialLoaderProvider.addPart('1');
    	$translateProvider.useLoader('$translatePartialLoader', {
    		urlTemplate: 'js/language/{part}-{lang}.json'
    	});
    	$translatePartialLoaderProvider.addPart('2');
    	$translateProvider.useLoader('$translatePartialLoader', {
      		urlTemplate: 'js/language/{part}-{lang}.json'
    	});
    	$translatePartialLoaderProvider.addPart('3');
    	$translateProvider.useLoader('$translatePartialLoader', {
      		urlTemplate: 'js/language/{part}-{lang}.json'
    	});*/
    $translateProvider.useSanitizeValueStrategy('sanitize');
    $translateProvider.useSanitizeValueStrategy('sanitizeParameters');
    $translateProvider.useStaticFilesLoader({
      prefix: 'json/language/',
      suffix: '.json'
    });
    $translateProvider.preferredLanguage('es_mx');
    //ROUTES CONFIG
    $stateProvider
      .state('login', {
        url: '/login',
        templateUrl: 'screens/login.html',
        controller: 'Login'
      })
      .state('registro', {
        url: '/registro',
        abstract: true,
        templateUrl: 'screens/registro.html',
        controller: 'Registro'
      })
      .state('registro.datos', {
        url: '/datos',
        views: {
          "contenido-registro": {
            templateUrl: 'screens/registroDatos.html'
          }
        }
      })
      .state('registro.exitoso', {
        url: '/codigo',
        views: {
          "contenido-registro": {
            templateUrl: 'screens/registroExitoso.html'
          }
        }
      })
      .state('recuperacion', {
        url: '/recuperacion',
        templateUrl: 'screens/recuperacion.html',
        controller: 'Recuperacion'
      })
      .state('app', {
        url: '/app',
        abstract: true,
        templateUrl: 'screens/app.html',
        controller: 'Aplicacion'
      })
/*      .state('app.cargar', {
        url: '/cargar',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/cargar.html',
            controller: "Cargar"
          }
        }
      })*/
      .state('app.inicio', {
        url: '/inicio',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/mapa.html',
            controller: "Inicio"
          },
        }
      })
      .state('app.menu', {
        url: '/menu',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/menu.html',
            controller: "Menu"
          },
        }
      })
      .state('app.income', {
        url: '/income',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/income.html',
            controller: "IncomeCtrl"
          },
        }
      })
      .state('app.news', {
        url: '/news',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/news.html',
            controller: "NewsCtrl"
          },
        }
      })
      .state('app.file-uploader', {
        url: '/file-uploader',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/file-uploader.html',
            controller: 'FileUploader'
          },
        }
      })
      .state('app.account-statement', {
        url: '/account-statement',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/account-statement.html',
            controller: 'AccountStatementCtrl'
          },
        }
      })
      .state('app.account-preferences', {
        url: '/account-preferences',
        views: {
          "contenido-inicio": {
            templateUrl: 'screens/account-preferences.html',
            controller: 'AccountPreferencesCtrl'
          },
        }
      })


    $urlRouterProvider.otherwise('/login');
    //$urlRouterProvider.otherwise('/login');



  })
