angular.module('siggo')
  .controller('Aplicacion', function($rootScope, $scope, Mapa, uiGmapGoogleMapApiManualLoader,
    Mensajes, $state, $ionicViewSwitcher, Socket, $window, Requests,
    $timeout, localStorageService, Mapa, News, Requirements) {

    //$scope.$on('$ionicView.beforeEnter',function(){ })
    //$scope.$on('$ionicView.afterEnter',function(){ })

    $scope.iniciado = false;
    $rootScope.vehicleOnline = false; // 0 no conectado, 1 conectado
    $rootScope.statusViaje = 0;
    Mapa.inicializa();
    $scope.backButton = false;

    $scope.noUnreadNews = News.noUnreadNews();

    $scope.$on("count_news", function() {
      console.log('.$on count_news');

      $scope.noUnreadNews = News.noUnreadNews();
    })



    $scope.$on("socket_connected", function() {
      console.log('.$on socket_connected');

      Requirements.getRequirements().then(function(noReg) {
        //$scope.requirements = Requirements.noRequirements();
      });

      Requirements.startObserver();
      News.startObserver();

      Socket.off("cerrar_sesion", $scope.validaSesion);
      Socket.on("cerrar_sesion", $scope.validaSesion);
      //Socket.emit("cerrar_sesion");

      Socket.off("restart_app", $scope.restartApp);
      Socket.on("restart_app", $scope.restartApp);

    });

    // broadcast
    $scope.$on("requirements_updated", function() {
      console.log('.$on requirements_updated');

      Requirements.noRequirements().then(function(total){
        $scope.noRequirements = total;
      },function(err){
        $scope.noRequirements = 0;
      });
    })

    // broadcast
    $scope.$on("cierra_sesion", function() {
      console.log('.$on cierra_sesion');

      $scope.cerrarSesion();
    })

    $scope.validaSesion = function(data) {
      console.log('.on cerrar_sesion');
      if (data.token != $rootScope.Usuario.Token) {
        Mensajes.alert("js.controllers.aplicacion.session", "js.controllers.aplicacion.session-expired", function() {
          $scope.cerrarSesion();
        });
      }

      if(data.forced) $scope.cerrarSesion();
    }


    $scope.cerrarSesion = function(data) {

      // disconnect vehicle
      if ($rootScope.vehicleOnline) $rootScope.conectar();



      Mensajes.showLoading('js.controllers.aplicacion.logout-loading');
      Socket.close();
      //if (window.cordova) window.hello.conexion(false);
      //if (window.cordova) window.BackgroundGeolocation.stop();
      Mapa.stopBgGeo();
      if (window.cordova) window.plugins.insomnia.allowSleepAgain();

      $rootScope.Usuario = null;
      $timeout(function() {
        Mensajes.hideLoading();
        localStorageService.clearAll();
        if (navigator.splashscreen) navigator.splashscreen.show();
        document.location.href = "index.html";
      }, 1000);
    }

    $scope.restartApp = function(data) {
      console.log('.on restart_app');
      Mensajes.showLoading('js.controllers.aplicacion.reset');
      Socket.close();
      //if (window.cordova) window.hello.conexion(false);
      //if (window.cordova) window.BackgroundGeolocation.stop();
      Mapa.stopBgGeo();
      if (window.cordova) window.plugins.insomnia.allowSleepAgain();

      $timeout(function() {
        Mensajes.hideLoading();
        if (navigator.splashscreen) navigator.splashscreen.show();
        document.location.href = "index.html";
      }, 1000);
    };

    $scope.cierraModal = function() {
      Mensajes.hideModal();
    };


    $scope.selfRequest = function() {
      if ($state.current.name !== "app.inicio") {
        $state.go("app.inicio");
      }
      Mensajes.confirm(
        "js.controllers.aplicacion.self-request.title", "js.controllers.aplicacion.self-request.text",
        function(data) {
          Requests.self()
            .then(function() {}, function() {
              Mensajes.alert(
                "js.controllers.aplicacion.self-request.error.title", "js.controllers.aplicacion.self-request.error.text",
                function() {});
            });
        });
    }


    $rootScope.$on('$stateChangeStart',
      function(event, toState, toParams, fromState, fromParams) {
        console.log('.$on root $stateChangeStart');

        if (toState.name == "app.income" || toState.name == "app.news" ||
          toState.name == "app.file-uploader" || toState.name == "app.account-statement" ||
          toState.name == "app.account-preferences"
          ) {
          $scope.backButton = true;
        } else {
          $scope.backButton = false;
        }
      });


    $scope.backToMenu = function() {
      console.warn('backToMenu');
      $window.history.back();
    }

    $scope.toggleMenu = function() {
     console.warn($state.current.name);
      if ($state.current.name == "app.inicio") {
        $state.go("app.menu");
      } else {
        $state.go("app.inicio");
      }
    }

  });
