angular.module('siggo')
  .controller('Login', function(sha1, $rootScope, $scope, Mensajes, $timeout,
    $ionicViewSwitcher, $state, $http, localStorageService, $cordovaAppVersion, configuration,LoadingModal,
    PushManager, toaster) {

    $scope.$on('$ionicView.beforeEnter', function() {
      console.log('.$on beforeEnter login');

      $rootScope.Usuario = localStorageService.get("Usuario");
      if ($rootScope.Usuario) {
        PushManager.registra();
        console.log("PushManager.registra");

        $ionicViewSwitcher.nextDirection('forward');
        LoadingModal.show();
      } else {
        $timeout(function() {
          if (navigator.splashscreen) navigator.splashscreen.hide();
        }, 1500)
      }
    });

    $scope.Usuario = {
      Usuario: "",
      Contrasena: ""
    };

    $scope.goRegistro = function() {
      $state.go("registro.datos", {
        'navDirection': 'forward'
      });
    }
    $scope.ValidarAcceso = function() {
      if ($scope.Usuario.Contrasena.length >= 8) {
        return true;
      } else {
        Mensajes.alert('js.controllers.login.title', 'js.controllers.login.error-on-login', function() {
          $scope.Usuario.Contrasena = "";
        })
      }
    }
    $scope.ValidarCorreo = function() {
      if ($scope.Usuario.Usuario && $scope.Usuario.Usuario.length > 0) {
        return true;
      } else {
        Mensajes.alert('js.controllers.login.title', 'js.controllers.login.error-on-login', function() {
          $scope.Usuario.Usuario = "";
        })
      }
    }

    $scope.version = function() {
      if (window.cordova) {
        $cordovaAppVersion.getVersionNumber().then(function(version) {
          $scope.Usuario.Version = version;
          $scope.Iniciar();
        });
      } else {
        $scope.Usuario.Version = "1";
        $scope.Iniciar();
      }
    }

    $scope.Iniciar = function() {
      //$scope.Usuario.Contrasena = sha1.hash($scope.Usuario.Contrasena);
      var user = angular.copy($scope.Usuario);
      user.Contrasena = sha1.hash(user.Contrasena);

      console.log($scope.Usuario);
      $http({
          method: 'Post',
          url: configuration.http.getUrl() + "newloginconductor",
          data: user,
          timeout: 15000
        })
        .success(function(respuesta) {
          Mensajes.hideLoading();
          console.log(respuesta);
          switch (respuesta.code) {
            case "540": // Error en la conexcion
              if (respuesta.mensaje) Mensajes.alert('js.controllers.login.title', null, function() {
                eval(respuesta.accion)
              }, respuesta.mensaje);
              else
                Mensajes.alert('js.controllers.login.title', 'js.controllers.login.error-on-login');
              break;
            case "541": // Usuario no existe o es incorrecto
              if (respuesta.mensaje) {
                Mensajes.alert('js.controllers.login.title', null, function() {
                  eval(respuesta.accion)
                }, respuesta.mensaje);
              } else {
                Mensajes.alert('js.controllers.login.title', 'js.controllers.login.error-on-login', function() {
                  $scope.Usuario.Contrasena = "";
                });
              }
              break;
            case "543": // Login exitoso
              //localStorageService.clearAll();
              // registra push
              // XXX: this is in rootscope $watch Usuario. avoid that watch!!!
              localStorageService.set("Usuario", respuesta.usuario);

              PushManager.registra();
              console.log("PushManager.registra");


              $rootScope.Usuario = respuesta.usuario;
              $ionicViewSwitcher.nextDirection('forward');
              LoadingModal.show();
              $rootScope.$broadcast('loading-modal');
              break;
          }
        })
        .error(function() {
          Mensajes.hideLoading();
          Mensajes.alert('js.controllers.login.title', 'js.controllers.login.error-on-login');
        })
    }

    $scope.Login = function() { // Funcion que hace el login
      if ($scope.ValidarCorreo()) {
        if ($scope.ValidarAcceso()) {
          Mensajes.showLoading('js.controllers.login.login-loading');
          $scope.version();
        }
      }
    }




  })
