angular.module('siggo')
  .controller('MapControl', function($scope, Mapa, $rootScope, Socket,
    PanicButtonModal, $log, $filter) {

    $scope.Viaje = $rootScope.Viaje

    $scope.apps = {
      google: false,
      apple: false,
      waze: false
    }

      //testing
    /*
    if (!window.cordova){ $scope.apps = { google: true, apple: true, waze: true } }
    */

    $rootScope.verificaApps = function() {
      if (window.cordova) {
        launchnavigator.isAppAvailable(launchnavigator.APP.GOOGLE_MAPS, function(isAvailable) {
          $scope.apps.google = isAvailable
        })
        launchnavigator.isAppAvailable(launchnavigator.APP.APPLE_MAPS, function(isAvailable) {
          $scope.apps.apple = isAvailable
        })
        launchnavigator.isAppAvailable(launchnavigator.APP.WAZE, function(isAvailable) {
          $scope.apps.waze = isAvailable
        })
      }
    }

    document.addEventListener("deviceready", function() {
      $rootScope.verificaApps();
    })

    document.addEventListener("resume", function() {
      $rootScope.verificaApps();
    })

    $rootScope.$watch("Viaje", function() {
      console.log('$watch root Viaje mapa');
      $scope.Viaje = $rootScope.Viaje
    }, true)

    $scope.statusViaje = $rootScope.statusViaje

    $rootScope.$watch("statusViaje", function() {
      console.log('$watch root statusViaje mapa');

      $scope.statusViaje = $rootScope.statusViaje
      if ($scope.statusViaje > 0) $rootScope.verificaApps();
    }, true)








    /* map controls */

    $scope.alarmActived = false;

    $scope.centraUbicacion = function() {
      Mapa.centrarUbicacion();
    }

    $scope.navegar = function(appName) {
      var origen = "" + $rootScope.mapa.ubicacion.posicion.latitude + "," + $rootScope.mapa.ubicacion.posicion.longitude;
      var destino = "" + $rootScope.mapa.ubicacion.posicion.latitude + "," + $rootScope.mapa.ubicacion.posicion.longitude;
      if ($rootScope.statusViaje == 1) {
        destino = "" + $rootScope.Marcadores[0].posicion.latitude + "," + $rootScope.Marcadores[0].posicion.longitude + "";
      } else if ($rootScope.statusViaje == 2) {
        if ($rootScope.Marcadores[1].posicion.latitude) {
          destino = "" + $rootScope.Marcadores[1].posicion.latitude + "," + $rootScope.Marcadores[1].posicion.longitude;
          Mapa.centrarUbicacion();
        } else {
          destino = "" + $rootScope.mapa.ubicacion.posicion.latitude + "," + $rootScope.mapa.ubicacion.posicion.longitude;
        }
      }
      $scope.lanzaNavegador(origen, destino, appName);
    }

    $scope.lanzaNavegador = function(origen, destino, appName) {
      var app;

      if (appName == 'google') app = launchnavigator.APP.GOOGLE_MAPS;
      if (appName == 'apple') app = launchnavigator.APP.APPLE_MAPS;
      if (appName == 'waze') app = launchnavigator.APP.WAZE;

      if (window.cordova)
        launchnavigator.isAppAvailable(app, function(isAvailable) {

          var options = {
            start: origen,
            app: app
          }

          if (window.device.platform.toLowerCase() == "android")
            options.launchMode = launchnavigator.LAUNCH_MODE.TURN_BY_TURN;

          launchnavigator.navigate(destino, options);
        });
    }

    $scope.showAlarmDescription = function(origen, destino, appName) {
      if ($scope.alarmDisabled) return;
      PanicButtonModal.show();
    }

    $scope.$on("emergency_alarm_on", function() {
      console.log('.$on emergency_alarm_on');
      $scope.alarmActived = true;
    });


    Socket.on("emergency_off", function() {
      console.log('.on emergency_off');
      $scope.alarmActived = false;
    });



    $rootScope.$watch("vehicleOnline", function(newVal, oldVal) {
      console.log('$watch root vehicleOnline mapa');

      $scope.hidePanicButton = newVal;
    })
    /* map controls end */



  })
