angular.module('siggo')
  .controller('Registro', function ($scope, Mensajes, localStorageService, $StatesModal, $CitiesModal, RequestFacade, toaster, $addVehicleModal, $ionicLoading) {

    $scope.steep = 0;

    $scope.data = localStorageService.get("signup");
    if (!$scope.data)
      $scope.data = {
        email: "",
        first_name: "",
        last_name_1: "",
        last_name_2: "",
        pass: "",
        city: "",
        state: "",
        code_country: "+52",
        address: "",
        ext_num: "",
        int_num: "",
        colony: "",
        zip_code: "",
        type: '',
        vehicles: []
      };

    console.log($scope.data);

    $scope.$watch('data', function (NuevoValor, ViejoValor) {
      console.log('$watch signup');

      localStorageService.set("signup", $scope.data);
    }, true);

    $scope.next = function () {
      $scope.steep++;
      if ($scope.steep == 5 && $scope.data.vehicles.length == 0) $scope.addVehicle();
    }

    $scope.preview = function () {
      $scope.steep--
    }

    var wait;

    $scope.verifyEmailAvailable = function () {
      clearTimeout(wait);
      wait = setTimeout(function () {

        RequestFacade.index('user', {
          type: 'email',
          value: $scope.data.email
        }).then(function (res) {
          $scope.data.emailAvailable = true;
        }, function (err) {
          $scope.data.emailAvailable = false;
          toaster.pop({
            title: 'Error ' + err,
            body: 'El correo no esta disponible porque ya esta siendo utilizado.',
            timeout: 5000,
            type: 'error'
          });
        });
      }, 1000);
    }

    $scope.verifyPhoneAvailable = function () {
      clearTimeout(wait);
      wait = setTimeout(function () {

        RequestFacade.index('user', {
          type: 'phone',
          value: $scope.data.phone
        }).then(function (res) {
          $scope.data.phoneAvailable = true;
        }, function (err) {
          $scope.data.phoneAvailable = false;
          toaster.pop({
            title: 'Error ' + err,
            body: 'El teléfono no esta disponible porque ya esta siendo utilizado.',
            timeout: 5000,
            type: 'error'
          });
        });
      }, 1000);
    }

    var checkEmail = function () {
      if ($scope.data.email && $scope.data.email.length > 0) {
        return true;
      } else {
        showAlert();
        $scope.steep = 1;
      }
    }

    var checkFirstName = function () {
      if ($scope.data.first_name.length > 0) {
        return true;
      } else {
        showAlert();
        $scope.steep = 1;
      }
    }

    var checkLastName = function () {
      if ($scope.data.last_name_1.length > 0 && $scope.data.last_name_2.length > 0) {
        return true;
      } else {
        showAlert();
        $scope.steep = 1;
      }
    }

    var checkPhone = function () {
      if ($scope.data.phone.length == 10) {
        return true;
      } else {
        showAlert()
        $scope.steep = 1;
      }
    }

    var checkAddress = function () {
      if ($scope.data.address && $scope.data.ext_num && $scope.data.zip_code && $scope.data.colony) {
        return true;
      } else {
        showAlert()
        $scope.steep = 2;
      }
    }

    var checkType = function () {
      if ($scope.data.type) {
        return true;
      } else {
        $scope.steep = 3;
        showAlert()
      }
    }

    var checkLocality = function () {
      if ($scope.data.state && $scope.data.city) {
        return true;
      } else {
        $scope.steep = 0;
        showAlert()
      }
    }

    var checkPass = function () {
      if ($scope.data.password.length >= 8) {
        return true;
      } else {
        toaster.pop({
          title: 'Error en contraseña',
          body: 'La contraseña debe tener entre 8 y 16 caracteres',
          type: 'error',
          timeout: 5000
        })
      }
    }

    var checkBank = function () {
      if ($scope.data.bank && $scope.data.bank_code) {
        return true;
      } else {
        $scope.steep = 4;
        showAlert();
      }
    }

    $scope.showStates = function () {
      console.log('test');
      $StatesModal.show().then(function (res) {
        $scope.data.state = res;
        $CitiesModal.show(res).then(function (res) {
          $scope.data.city = res.Ciudad;
          $scope.data.whatsapp = res.phone;
        });
      });
    }

    $scope.showCities = function () {
      console.log('test');
      if (!$scope.data.state) $scope.showStates();
      else {
        $CitiesModal.show($scope.data.state).then(function (res) {
          $scope.data.city = res.Ciudad;
          $scope.data.whatsapp = res.phone;
        });
      }
    };

    $scope.addVehicle = function () {
      $addVehicleModal.show().then(function (res) {
        $scope.data.vehicles.push(res);
      });
    };

    $scope.removeVehicle = function (index) {
      console.log(index);
      $scope.data.vehicles.splice(index, 1);
    }

    var showAlert = function () {
      Mensajes.alert('js.controllers.registro.title', "js.controllers.registro.fill-fields", function () {

      })
    }

    var signupSuccess = function () {
      toaster.pop({
        type: 'success',
        title: '¡Listo!',
        body: 'El registro de la cuenta se realizó correctamente',
        timeout: 5000
      });
      localStorageService.remove('signup');
      $scope.steep = 10;
    }

    $scope.sendWhatsapp = function () {

      window.open("https://api.whatsapp.com/send?phone=" + $scope.data.whatsapp + "&text=Hola, mi nombres es " + $scope.data.first_name + ' ' + $scope.data.last_name_1 + ", mi número de Registro es " + $scope.data.owner + " y a continuación les envío los documentos requeridos en https://registro.siggo.com.mx para completar la activación de mi cuenta con Siggo.", "_blank");

    }

    $scope.signup = function () {
      if (checkLocality()) {
        if (checkEmail()) {
          if (checkFirstName()) {
            if (checkLastName()) {
              if (checkPhone()) {
                if (checkPass()) {
                  if (checkAddress()) {
                    if (checkType()) {
                      if ($scope.data.type != 'driver') {
                        if (checkBank()) {
                          $ionicLoading.show({
                            template: "Registrando..."
                          });
                          console.log($scope.data);
                          RequestFacade.store('user', $scope.data).then(function (res) {
                            var id = res.insertId;
                            $scope.data.owner = id;
                            RequestFacade.store('partner', $scope.data).then(function (res) {

                              for (var i = 0; i < $scope.data.vehicles.length; i++) {
                                var _car = $scope.data.vehicles[i];
                                _car.owner = id;
                                RequestFacade.store('vehicle', _car).then(function (res) {}, function (err) {
                                  toastr.error('Ocurrió un error al procesar el registro de Vehiculo ' + _car.plate, 'Error ' + err);
                                });
                              }

                              if ($scope.data.type == 'full') {
                                RequestFacade.store('driver', $scope.data).then(function (res) {
                                  signupSuccess(id);
                                  $ionicLoading.hide();
                                }, function (err) {
                                  toaster.pop({
                                    title: 'Error al registrar el Conductor',
                                    body: 'Ocurrió un error al registrar la cuenta como Conductor',
                                    type: 'error',
                                    timeout: 5000
                                  });
                                  $ionicLoading.hide();
                                });
                              } else {
                                signupSuccess(id);
                                $ionicLoading.hide();
                              }
                            });
                          }, function (err) {
                            toaster.pop({
                              title: 'Error al registrar la cuenta',
                              body: 'Ocurrió un error al registrar la cuenta',
                              type: 'error',
                              timeout: 5000
                            });
                            $ionicLoading.hide();
                          });

                        }
                      } else {
                        $ionicLoading.show({
                          template: "Registrando..."
                        });
                        console.log($scope.data);
                        RequestFacade.store('user', $scope.data).then(function (res) {
                          var id = res.insertId;
                          $scope.data.owner = id;
                          RequestFacade.store('driver', $scope.data).then(function (res) {
                            signupSuccess(id);
                            $ionicLoading.hide();
                          }, function (err) {
                            toaster.pop({
                              title: 'Error al registrar el Conductor',
                              body: 'Ocurrió un error al registrar la cuenta como Conductor',
                              type: 'error',
                              timeout: 5000
                            });
                            $ionicLoading.hide();
                          });
                        })
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

  });