angular.module('siggo')
.directive('languageSelector', function(){
	return {
		// scope: {}, // {} = isolate, true = child, false/undefined = no change
		controller: function($scope, $element, $attrs, languageService) {

			$scope.languages = [
				{value:'es_mx',label:'Español Latino'},
				{value:'en_us',label:'English'}
			];

			$scope.setLanguage = function(language){
				languageService.set(language);
				console.log('setLanguge',language);
			}

			var language = languageService.get();
			if(!language)$scope.language = 'es_mx';
			else $scope.language = language;



		},
		templateUrl:'screens/directives/language-selector.html'
	};
})
.service('languageService', function($translate,localStorageService, $rootScope){
	
	var set = function(language){
		localStorageService.set('language',language);
		load();	
	};

	var load = function(){
		var language = localStorageService.get('language');
		if(!language) {
			language = "es_mx";
			localStorageService.set('language',language);
		}
		$translate.use(language);
		console.log("load language");
	};

	var get = function(){
		var language = localStorageService.get('language');
		return language;
	}

	return{
		set:set,
		load:load,
		get:get
	}

});