angular.module('siggo')
  .factory('DeviceSettingsMonitor', function ($interval, $timeout, deviceConfiguration,
    $ionicPopup, $ionicPlatform, $filter) {

    var mockCheckInterval;
    var popupVisible = false;

    $ionicPlatform.ready(function () {
      if (window.cordova) {
        mockCheckInterval = setInterval(function () {
          //console.log('setInterval mockCheckInterval device-settings-monitor');

          cordova.plugins.diagnostic.isLocationAvailable(successCallback, errorCallback);
        }, 5000);
      }
    });

    document.addEventListener("resume", function () {
      if (window.cordova)
        cordova.plugins.diagnostic.isLocationAvailable(successCallback, errorCallback);
    }, false);

    function successCallback(enabled) {
      if (!enabled && popupVisible) return;
      if (enabled && !popupVisible) return;
      if (eval(!enabled)) {
        if (buttonLocked) setTimeout(function () {
          buttonLocked = false;
        }, 1000);
        if (myPopup) return;

        showPopup();
        popupVisible = true;
      } else {
        //clearInterval(mockCheckInterval);
        closePopup();
        buttonLocked = false;
        popupVisible = false;
      }
    }

    function errorCallback(error) {
      console.log("mocklocation error: ", error);
      setTimeout(function () {
        window.plugins.mocklocation.check(successCallback, errorCallback);
      }, 1000);
    }






    var myPopup = null;
    var buttonLocked = false;

    var showPopup = function () {

      myPopup = $ionicPopup.show({
        template: $filter('translate')('js.services.device.settings-monitor.template'),
        title: $filter('translate')('js.services.device.settings-monitor.title'),
        //scope: $scope,
        hardwareBackButtonClose: false,
        buttons: [{
          text: $filter('translate')('js.services.device.settings-monitor.btn-setting'),
          //type: 'button-positive',
          onTap: function (e) {
            // https://github.com/guyromb/Cordova-open-native-settings
            if (buttonLocked) {
              e.preventDefault();
              return;
            }


            buttonLocked = true;
            cordova.plugins.settings.open("location", function () {
              console.log("MOCK 1.S");
            }, function () {
              console.log("MOCK 1.E");
            });

            e.preventDefault();
          }
        }]
      });
    }


    var closePopup = function () {
      if (!myPopup) return;
      myPopup.close();
      myPopup = null;
    }



    return {
      /*
      startTimerOnline: function() {
        startTimerOnline();
      },
      stopTimerOnline: function() {
        stopTimerOnline();
      }
      */
      // aun no diseñados los de abajo
    };


  })