"use strict";

angular.module('siggo')
  .factory('Mapa', function ($rootScope, uiGmapIsReady, uiGmapGoogleMapApi, $animate, $timeout,
    Socket, $log, $ionicPlatform, configuration) {

    var posicion = null;
    var locationStatus = 2; /* 0 libre, 1 seguir, 2 zoom, 3 in fit*/

    var timeoutCenter;
    var timeoutWaitCenter = 45000;

    var intervalPosition;
    var intervalWaitPosition = 5000;

    var intervalCenter;
    var intervalWaitCenter = 1000; // is to faster

    var zoomBase = 16,
      zoomViaje = 18;

    //creo que si el mapa está iniciado
    var iniciado = false;

    var pausedApp = false;

    var bgGeo;




    // TEST: reinicia_geolocation error when data restriction device
    /*
    setTimeout(function(){
      if (window.cordova) bgGeo.stop()
    },10000)
    */

    var inicializa = function () {
      uiGmapGoogleMapApi.then(function (map) {
        console.log(map);
        //console.log("uiGmapGoogleMapApi");
        if (document.getElementById("Mapa")) {

          $animate.addClass(document.getElementById("Mapa"), 'muestra-mapa')
          obtenerUbicacion();

          Socket.off("reinicia_geolocation", reiniciaGeolocation);
          Socket.on("reinicia_geolocation", reiniciaGeolocation);
        }

      })


      //https://github.com/transistorsoft/cordova-background-geolocation-lt
    }




    //$rootScope.$watch('locationStatus', function(newValue, oldValue) {
    //console.log(oldValue+" ---> "+newValue)
    //});




    // only need for explorer???
    //////// creo que deberia quitarse porque bg ya buscatest ahorro //
    if (!window.cordova) {
      intervalPosition = setInterval(function () {
        console.log('setInterval intervalPosition mapa');

        obtenerUbicacion();
      }, intervalWaitPosition)
    }

    intervalCenter = setInterval(function () {
      //console.log('setInterval intervalCenter mapa');

      if (locationStatus != 0 && !pausedApp)
        centrarUbicacion();
    }, intervalWaitCenter)

    //evita consumo de datos cuando app está pausada
    $ionicPlatform.ready(function () {
      document.addEventListener("pause", function () {
        pausedApp = true;
      }, false);
      document.addEventListener("resume", function () {
        pausedApp = false;
      }, false);

    });




    // reinicia BackgroundGeolocation
    var reiniciaGeolocation = function () {
      console.log('.on reinicia_geolocation');
      //var locationStatus = 1;

      //reinicia servico
      if (window.cordova) bgGeo.stop()
      setTimeout(function () {
        iniciaGeolocation();
      }, 250);

      //reinicia Interval
      // only need for explorer???
      //////// creo que deberia quitarse porque bg ya buscatest ahorro //
      /*
      if (!window.cordova) {
        clearInterval(intervalPosition);
        intervalPosition = setInterval(function() {
          console.log('setInterval intervalPosition mapa');

          obtenerUbicacion();
        }, intervalWaitPosition)
      }
      */
    }

    var iniciaGeolocation = function () {
      if (iniciado) {
        if (window.cordova) bgGeo.start(function () {
          bgGeo.changePace(true);
        });
      } else $timeout(function () {
        if (window.cordova) bgGeo.start(function () {
          bgGeo.changePace(true);
        });
      }, 1000)
      cordova.plugins.backgroundMode.enable();
    }


    // obtener ubicacion en device
    var obtenerUbicacion = function () {
      //console.log("obtenerUbicacion");
      if (window.cordova && bgGeo) {
        bgGeo.getCurrentPosition(ubicacionExitoDevice, ubicacionError, {
          timeout: 15000
        });
      } else {
        obtenerUbicacionExplorador();
      }
    }

    // obtener ubicacion en explorador
    var obtenerUbicacionExplorador = function () {
      //console.log("obtenerUbicacionExplorador");
      if (posicion) navigator.geolocation.clearWatch(posicion);
      posicion = navigator.geolocation.watchPosition(ubicacionExitoExplorador, ubicacionError, {
        enableHighAccuracy: true,
        timeout: 15000,
        frequency: 5000
      });
    }



    // ubicacion exito explorador
    var ubicacionExitoExplorador = function (posicion) {
      //console.log("ubicacionExitoExplorador");

      if ($rootScope.mapa.ultima.latitude != posicion.coords.latitude || $rootScope.mapa.ultima.longitude != posicion.coords.longitude) {

        Socket.emit("servicio_posicion", {
          latitude: posicion.coords.latitude,
          longitude: posicion.coords.longitude
        })

        $rootScope.mapa.ultima.latitude = posicion.coords.latitude;
        $rootScope.mapa.ultima.longitude = posicion.coords.longitude;

        $rootScope.mapa.ubicacion.posicion = {
          latitude: posicion.coords.latitude,
          longitude: posicion.coords.longitude
        };

      }

    }




    // ubicacion exito device
    var ubicacionExitoDevice = function (respuesta) {
      console.log("ubicacionExitoDevice", respuesta);

      if ($rootScope.mapa.ultima.latitude != respuesta.coords.latitude || $rootScope.mapa.ultima.longitude != respuesta.coords.longitude) {

        if (respuesta.posicion) respuesta.coords = respuesta.posicion
        var time = 1;
        if ($rootScope.mapa.ubicacion.posicion.latitude == 0) {
          time = 1000;
        }


        $rootScope.mapa.ultima.latitude = respuesta.coords.latitude;
        $rootScope.mapa.ultima.longitude = respuesta.coords.longitude;

        $rootScope.mapa.ubicacion.posicion = {
          latitude: respuesta.coords.latitude,
          longitude: respuesta.coords.longitude
        };

      }

    }



    var ubicacionError = function (error) {
      console.error("ubicacionError", error);
    }





    var centrarUbicacion = function (position) {

      if (position != undefined) {
        $timeout(function () {
          try {
            $rootScope.mapa.centro = position;
          } catch (e) {}
        }, 1);

        // crear timer para centrar
        locationStatus = 0;
        clearTimeout(timeoutCenter);
        timeoutCenter = setTimeout(function () {
          console.log("timeoutCenter");
          locationStatus = 1;
        }, timeoutWaitCenter);


      } else if (locationStatus == 0) {
        $timeout(function () {
          $rootScope.mapa.centro = $rootScope.mapa.centro;
        }, 1)
      } else if (locationStatus == 1) {
        $timeout(function () {
          $rootScope.mapa.centro = angular.copy($rootScope.mapa.ubicacion.posicion);
          if ($rootScope.mapa.zoom == zoomViaje) locationStatus = 2;
        }, 1)
        clearTimeout(timeoutCenter);
      } else if (locationStatus == 3) {
        $timeout(function () {
          $rootScope.mapa.centro = angular.copy($rootScope.mapa.ubicacion.posicion);
        }, 1)
        $rootScope.mapa.zoom = zoomViaje;
        locationStatus == 1;
        //clearTimeout(timeoutCenter);
      } else {
        $timeout(function () {
          $rootScope.mapa.centro = angular.copy($rootScope.mapa.ubicacion.posicion);
        }, 1)
        $rootScope.mapa.zoom = zoomViaje;
        clearTimeout(timeoutCenter);
      }
      muestraBotonCentrar();
    }



    var muestraBotonCentrar = function () {
      //console.log("muestraBotonCentrar");

      if (locationStatus == 2) {
        //oculta boton
        if (document.getElementById("ubicacion")) $animate.removeClass(document.getElementById("ubicacion"), 'no-centro')
      } else {
        //muestra boton
        if (document.getElementById("ubicacion")) $animate.addClass(document.getElementById("ubicacion"), 'no-centro')
      }
    }









    // detiene si esta desconectado
    document.addEventListener("pause", function () {
      if (window.cordova && $rootScope.vehicleOnline == false) bgGeo.stop();
    }, false);

    document.addEventListener("resume", function () {
      if (window.cordova) bgGeo.start(function () {
        bgGeo.changePace(true);
      });
    })

    // https://github.com/christocracy/cordova-plugin-background-geolocation
    // https://github.com/transistorsoft/cordova-background-geolocation-lt/tree/master/docs
    document.addEventListener("deviceready", function () {
      if (window.cordova && $rootScope.Usuario) {
        bgGeo = window.BackgroundGeolocation;

        bgGeo.configure({

          //[Geolocation] Common Options

          desiredAccuracy: 0, // precision 10m. 0 10 100 1000 mayor numero menos energia
          distanceFilter: 20, // cada 20m se actualiza
          disableElasticity: false, // true. cambia distanceFilter de acuerdo a velocidad

          //ios
          stationaryRadius: 30, // ios;  al detenerce a los 30m se reactiva

          //android
          // locationUpdateInterval: 000, // is override by distanceFilter
          //fastestLocationUpdateInterval: 5000, // fastest update interval. Causes error  whit distanceFilter??
          //deferTime:10000,  // send by lots. In end route has error


          // Activity Recognition Options

          //activityRecognitionInterval: 5000,
          stopTimeout: 360, // minutes to turn off

          //ios
          activityType: 'AutomotiveNavigation',


          // HTTP & Persistence Options

          url: configuration.http.getUrl() + 'background',
          method: 'POST',
          autoSync: true,
          extras: {
            token: $rootScope.Usuario.Token,
            id: $rootScope.Usuario.Id
          },


          // Application Options

          //heartbeatInterval:60,
          stopOnTerminate: false,
          // startOnBoot: true,

          //ios
          preventSuspend: true,

          //android
          foregroundService: true, //android service can't hide the notification
          notificationPriority: BackgroundGeolocation.NOTIFICATION_PRIORITY_MIN,
          notificationTitle: 'Siggo activo.',
          notificationText: 'Dispositivo en línea.',
          //forceReloadOnLocationChange:true,
          forceReloadOnBoot: true,


          //Logging & Debug Options

          debug: false,

          license: "c93d2629a54946995f520b17214f5080c43b9ca8eb4d523194ed5fd5dd7d182b",
        }, function (state) {
          console.log('bgGeo: ', state)
          bgGeo.on('location', ubicacionExitoDevice, ubicacionError);
          if (state.enabled) bgGeo.start(function () {
            console.log("se inicio bgGeo");
            iniciado = true;
            bgGeo.changePace(true);
          });
          bgGeo.changePace(true);
        });
      }
    });

    var styles = [{
      "featureType": "poi.business",
      "stylers": [{
        "visibility": "off"
      }]
    }, {
      "featureType": "poi.park",
      "elementType": "labels.text",
      "stylers": [{
        "visibility": "off"
      }]
    }, {
      "featureType": "transit.line",
      "stylers": [{
        "visibility": "off"
      }]
    }];


    $rootScope.mapa = {
      iniciado: false,
      //centro inicial del mapa
      centro: {
        latitude: 20.6739383,
        longitude: -103.4054533
      },
      ultima: {
        latitude: 0,
        longitude: 0
      },
      //Zoom inicial del mapa, da una vista de toda la ZMG
      zoom: 16,
      //opciones de mapa (google maps api v3 docs)
      opciones: {
        ///////////minZoom: 4,
        //define que no se van a manejar tipos de mapas por medio de control
        mapTypeControl: false,
        //define que no se va a manejar navegacion por medio de control
        panControl: false,
        //define que no se va a projectar el control default de zoom
        zoomControl: false,
        //define que no se va a mostrar la escala
        scaleControl: false,
        //define que no se va a utilizar el control de vista
        streetViewControl: false,
        fullscreenControl: false,
        styles: [{
          "featureType": "poi",
          "elementType": "all",
          "stylers": [{
            "visibility": "on"
          }]
        }, {
          "featureType": "transit",
          "elementType": "all",
          "stylers": [{
            "visibility": "on"
          }],
        }],
        // styles: styles,
        //https://snazzymaps.com/editor
      },
      eventos: {
        drag: function (event) {
          //console.log("drag");
          locationStatus = 0;

          // limpiar timeout para centrar
          clearTimeout(timeoutCenter);


          // google.maps.event.trigger(event, 'resize');
        },
        zoom_changed: function (event) {
          console.log("zoom");
          var d = angular.element(document.getElementsByClassName("marcador-animacion")[0])
          d.addClass("off");
          $timeout(function () {
            d.removeClass("off");
          }, 600);
          /*
          if (event.zoom > 18) {
              $rootScope.mapa.opciones.styles[1].stylers[0].visibility = "on"
          } else $rootScope.mapa.opciones.styles[1].stylers[0].visibility = "off"
          */
          // google.maps.event.trigger(event, 'resize');
        },
        center_changed: function (event) {
          //console.log("center");

          // crear timeout para centrar
          timeoutCenter = setTimeout(function () {
            if (locationStatus != 3) { //si viene de fitBounds
              locationStatus = 1;
            }

          }, timeoutWaitCenter);


          //var centrado = $rootScope.mapa.centro.latitude == $rootScope.mapa.ubicacion.posicion.latitude && $rootScope.mapa.centro.longitude == $rootScope.mapa.ubicacion.posicion.longitude;
          muestraBotonCentrar();
          // google.maps.event.trigger(event, 'resize');
        }
      },
      ubicacion: {
        posicion: {
          latitude: 0,
          longitude: 0
        },
        centrado: true,
        opciones: {
          draggable: false,
          zIndex: 10000,
          shadow: 'none',
          content: '<div class="marcador-ubicacion" ></div>',
          visible: true,
          // animation: "marcador-animacion",
          width: "20px",
          height: "20px",
          shape: {
            coords: [0, 0, 0, 20, 20, 20, 20, 0],
            type: 'poly',
          },
        },
        eventos: {
          position_changed: function () {
            //console.log("position_changed");

            var d = angular.element(document.getElementsByClassName("marcador-animacion")[0])
            d.removeClass("off");
          }
        }
      },
      origen: {
        posicion: {
          latitude: 0,
          longitude: 0
        },
        options: {
          draggable: false,
          zIndex: 10000,
          shadow: 'none',
          content: '<div class="marcador-origen"><div class="lineas"></div><button><i class="icon ion-person"></i></button></div>',
          visible: true,
          shape: {
            coords: [0, 0, 0, 51, 51, 40, 40, 0],
            type: 'poly',
          },
        },
        eventos: {}
      },
      destino: {
        posicion: {
          latitude: 0,
          longitude: 0
        },
        opciones: {
          draggable: false,
          zIndex: 10000,
          shadow: 'none',
          content: '<div class="marcador-ubicacion" ></div>',
          visible: false,
          shape: {
            coords: [0, 0, 0, 51, 51, 40, 40, 0],
            type: 'poly',
          },
        },
        eventos: {}
      }

    };




    /* ----------- AVOID MAP INFOWINDOW ---------------- */
    function fixInfoWindow() {
      //Here we redefine set() method.
      //If it is called for map option, we hide InfoWindow, if "noSuppress" option isnt true.
      //As Google doesn't know about this option, its InfoWindows will not be opened.
      var set = google.maps.InfoWindow.prototype.set;
      google.maps.InfoWindow.prototype.set = function (key, val) {
        if (key === 'map') {
          if (!this.get('noSuppress')) {
            console.log('This InfoWindow is suppressed. To enable it, set "noSuppress" option to true');
            return;
          }
        }
        set.apply(this, arguments);
      }
    }
    // where i can put this ???
    setTimeout(function () {
      fixInfoWindow()
    }, 5000);
    /* ----------------- AVOID MAP INFOWINDOW - END ----------------- */



    $rootScope.Marcadores = [{
      id: 1,
      posicion: {
        latitude: 20.6739383,
        longitude: -103.4054533
      },
      options: {
        draggable: false,
        shadow: 'none',
        content: '<div class="marcador-origen" id="origen" ><div class="lineas"></div><button><i class="icon ion-person"></i></button></div>',
        visible: false,
        shape: {
          coords: [0, 0, 0, 51, 51, 40, 40, 0],
          type: 'poly',
        },
      }
    }, {
      id: 2,
      posicion: {
        latitude: 20.6739383,
        longitude: -103.4054533
      },
      options: {
        draggable: false,
        shadow: 'none',
        content: '<div class="marcador-origen destino" id="destino" ><div class="lineas"></div><button><i class="icon ion-android-navigate"></i></button></div>',
        visible: false,
        shape: {
          coords: [0, 0, 0, 51, 51, 40, 40, 0],
          type: 'poly',
        },
      }
    }];








    return {
      inicializa: function () {
        inicializa();
      },
      startBgGeo: function () {
        iniciaGeolocation();
      },
      stopBgGeo: function () {
        if (iniciado)
          if (window.cordova) bgGeo.stop();
      },
      centrarUbicacion: function (position) {
        ////// omitir estos????


        if (locationStatus == 0) {
          locationStatus = 1;
        } else if (locationStatus == 1) {
          locationStatus = 2;
        }

        centrarUbicacion(position);
      },
      restablecerZoom: function (zoom) {
        if (zoom != undefined)
          $rootScope.mapa.zoom = zoomViaje;
      },
      zoomLimites: function (bnds) {
        locationStatus = 0;
        //clearInterval(intervalCenter);
        clearTimeout(timeoutCenter);

        timeoutCenter = setTimeout(function () {
          console.log("timeoutCenter");
          locationStatus = 3;
        }, timeoutWaitCenter);
        /*
         */

        $rootScope.mapa.getGMap().fitBounds(bnds);

      }
    };
  })



// Bracground ayuda
// https://www.npmjs.com/package/cordova-plugin-mauron85-background-geolocation