angular.module('siggo')
  .factory('Mensajes', function($ionicLoading, $ionicPopup, $cordovaToast, $ionicActionSheet, $ionicModal, $rootScope, $timeout, $translate) {

      var alertPopUp = null;
      var confirmPopUp = null;
      var promptPopUp = null
      var selectPopUp = null;
      var options = null;
      var modal = null;
      var messengerModal = null;
      var alertFree = null
      var selectPopUpMul = null;

      var closeSelect = function() {
        angular.element(document.getElementsByClassName('modal-backdrop')[0]).unbind('click', closeSelect)
        if (selectPopUp) selectPopUp.close();
      }

      var closeSelectMultiple = function() {
        angular.element(document.getElementsByClassName('modal-backdrop')[0]).unbind('click', closeSelectMultiple)
        if (selectPopUpMul) selectPopUpMul.close();
      }
      var closeAlertFree = function() {
        angular.element(document.getElementsByClassName('modal-backdrop')[0]).unbind('click', closeAlertFree)
        if (alertFree) alertFree.close();
      }
      return {
        showLoading: function(texto) {
          $translate([texto]).then(function(translations) {
            if (texto != "") texto = "<div style='margin-top:1vh; margin-bottom:1vh'>" + translations[texto] + "</div>"
            $ionicLoading.show({
              template: '<div style="width:100%"><ion-spinner icon="android" class="spinner-dark"></ion-spinner></div>' + texto
            });
          })
        },
        hideLoading: function() {
          $ionicLoading.hide();
        },
        toast: function(msg) {
          $cordovaToast.showShortBottom(msg);
        },
        alert: function(titulo, texto, funcion, textoAbierto) {
          funcion = funcion || function() {};
          textoAbierto = textoAbierto || "";
          if (alertPopUp) alertPopUp.close();
          $translate(['common.button-ok', titulo, texto]).then(function(translations) {
            alertPopUp = $ionicPopup.alert({
              title: translations[titulo],
              template: (translations[texto]) ? translations[texto] : textoAbierto,
              okText: translations['common.button-ok'],
              okType: "button",
            });
            alertPopUp.then(function(res) {
              funcion();
            });
          });
        },
        prompt: function(titulo, texto, funcion, tipo, placeholder) {
          tipo = tipo || "text";
          placeholder = placeholder || "";
          if (promptPopUp) promptPopUp.close();
          $translate(['common.button-ok', 'common.button-cancel', titulo, texto, placeholder]).then(function(translations) {
            promptPopUp = $ionicPopup.prompt({
              title: translations[titulo],
              template: translations[texto],
              inputType: tipo,
              cssClass: "alert-prompt",
              cancelText: translations['common.button-cancel'],
              cancelType: "button-default",
              okText: translations['common.button-ok'],
              okType: "button",
              inputPlaceholder: translations[placeholder]
            })
            promptPopUp.then(function(res) {
              if (!_.isUndefined(res)) funcion(res);
            });
          })
        },
        alertTemplate: function(scope, template, title, buttons, clase) {
          buttons = buttons || [{ // Array[Object] (optional). Buttons to place in the popup footer.
            text: $rootScope.idioma.General[6],
            type: 'button-default',
            onTap: function(e) {
              timePopUp.close();
            }
          }, ]
          if (alertFree) alertFree.close();
          alertFree = $ionicPopup.show({
            title: title,
            cssClass: clase,
            templateUrl: template, // String (optional). The URL of an html template to place in the popup   body.
            scope: scope, // Scope (optional). A scope to link to the popup content.
            buttons: buttons
          });
          $timeout(function() {
            angular.element(document.getElementsByClassName('modal-backdrop')[0]).bind('click', closeAlertFree)
          }, 300);
        },
        closeAlert: function() {
          closeAlertFree()
        },
        select: function(scope) {

          if (selectPopUp) selectPopUp.close();
          selectPopUp = $ionicPopup.show({
            //title: title, // String. The title of the popup.
            cssClass: 'select-popup',
            templateUrl: 'screens/modals/select.html', // String (optional). The URL of an html template to place in the popup   body.
            scope: scope, // Scope (optional). A scope to link to the popup content.
            buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
              text: $rootScope.idioma.General[6],
              type: 'button-default',
              onTap: function(e) {
                timePopUp.close();
              }
            }, ]
          });
          $timeout(function() {

            angular.element(document.getElementsByClassName('modal-backdrop')[0]).bind('click', closeSelect)
          }, 300);
        },
        closeSelect: function() {
          closeSelect()
        },
        selectMultiple: function(scope) {

          if (selectPopUpMul) selectPopUpMul.close();
          selectPopUpMul = $ionicPopup.show({
            //title: title, // String. The title of the popup.
            cssClass: 'select-popup',
            templateUrl: 'screens/modals/selectMultiple.html', // String (optional). The URL of an html template to place in the popup   body.
            scope: scope, // Scope (optional). A scope to link to the popup content.
            buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
              text: $rootScope.idioma.General[6],
              type: 'button-default',
              onTap: function(e) {
                //timePopUp.close();
              }
            }, ]
          });
        },
        closeSelectMultiple: function() {
          closeSelectMultiple();
        },
        confirm: function(titulo, texto, funcion, btn1, btn2, closable, callback) {
          $translate(['common.button-ok', 'common.button-cancel', titulo, texto, btn1, btn2]).then(function(translations) {
            if (confirmPopUp) confirmPopUp.close();
            callback = callback || false
            btn1 = (!btn1) ? translations['common.button-ok'] : translations[btn1];
            btn2 = (!btn2) ? translations['common.button-cancel'] : translations[btn2];
            closable = closable || function() {
              return true
            };
            confirmPopUp = $ionicPopup.confirm({
              title: translations[titulo],
              template: "<div>" + translations[texto] + "</div>" +
                '<div id="botones_confirm"></div>',
              buttons: [{
                text: btn2,
                type: 'button-default',
                onTap: function() {
                  return 0;
                }
              }, {
                text: btn1,
                type: "button",
                onTap: function() {
                  return 1;
                }
              }]
            });
            if (!closable()) $timeout(function() {
              $(".popup-buttons").addClass("ng-hide");
              $(".popup-visible").removeClass("ng-hide");
            }, 10);
            confirmPopUp.then(function(res) {
              if (res) {
                confirmPopUp.close();
                funcion(res);
              } else {
                if (callback) funcion(res);
                confirmPopUp.close();
              }
            })
          })
        },
        showActionSheet: function(title, buttons, destructive, cancel, result) {
          var settings = {
            buttons: buttons,
            buttonClicked: function(index) {
              result(index, buttons[index])
              options();
            },
            cancel: function() {
              result(-1, null)
            }
          }
          if (cancel) settings.cancelText = cancel
          if (title) settings.titleText = title
          if (destructive) {
            settings.destructiveText = destructive.text
            settings.destructiveButtonClicked = function() {
              options();
              destructive.funcion(destructive)
            }
          }
          options = $ionicActionSheet.show(settings);
        },
        showModal: function(template, direction, scope) {

          if ($rootScope.PeticionActiva == true) return;

          // cierra si existe otro modal
          if (modal && modal._isShown) {
            modal.hide();
            console.warn("modal removed");
          }


          var direction = direction || ''
          switch (direction) {
            case 'left':
              direction = 'slide-in-left'
              break;
            case 'right':
              direction = 'slide-in-right'
              break;
            case 'up':
              direction = 'slide-in-down'
              break;
            default:
              direction = 'slide-in-up'
              break
          }

          $ionicModal.fromTemplateUrl(template, {
            scope: scope,
            animation: direction,
            //hardwareBackButtonClose: false, porque lo cancelaron
            backdropClickToClose: false,
          }).then(function(mod) {
              try {
                modal = mod;
                console.log(modal);
                if (modal) modal.show();
              } catch (err) {
                console.error("error modal");
                  $ionicModal.fromTemplateUrl(template, {
                    scope: scope,
                    animation: direction,
                    backdropClickToClose: false,
                  }).then(function(mod) {
                  modal = mod;
                  console.log(modal);
                  if (modal) modal.show();
                  else console.error("modal");
                });
              };
          });
      },
      hideModal: function() {
          if (modal && modal._isShown) {
            modal.hide();
            console.warn("modal removed");
          }


        },
        showMessengerModal: function(template, scope) {

          // cierra si existe otro modal
          if (messengerModal) {
            messengerModal.remove()
              .then(function() {
                messengerModal = null;
                $ionicModal.fromTemplateUrl(template, {
                  scope: scope,
                  animation: 'slide-in-down',
                  //hardwareBackButtonClose: false, porque lo cancelaron
                  backdropClickToClose: false,
                }).then(function(mod) {
                  messengerModal = mod;
                  messengerModal.show();
                });
              });
          } else {
            $ionicModal.fromTemplateUrl(template, {
              scope: scope,
              animation: 'slide-in-down',
              //hardwareBackButtonClose: false, porque lo cancelaron
              backdropClickToClose: false,
            }).then(function(mod) {
              messengerModal = mod;
              messengerModal.show();
            });
          }
        },
        hideMessengerModal: function() {
          if (messengerModal) {
            messengerModal.remove()
              .then(function() {
                messengerModal = null;
              });
          }
        }
    }
  })
