angular.module('siggo')
  .factory('MessengerReceiver',
    function($q, Mensajes, $rootScope, News, Socket, $state, MessengerFeedback) {


      var startMonitor = function() {
        Socket.on("messenger_new", messageReceived);
      }

      $rootScope.$on("socket_connected", function() {
        console.log('.$on socket_connected');

        startMonitor();
      });



      var messageReceived = function(data) {
        console.log(".on messenger_new");
        Socket.emit("driver_messenger_new_received", {
          id: data.id
        });
        messageAnalizer(data);
      }


      var messageAnalizer = function(data) {
        if (data.type == "alert") {
          Mensajes.alert(data.info.title, data.info.description);
          return;
        }

        if (data.type == "modal") {
          createModal(data.info);
          return;
        }
      }


      var createModal = function(info) {
        var $myScope = $rootScope.$new(true);
        $myScope.info = info;
        $myScope.cierraModal = cierraModal;
        $myScope.goToState = goToState;
        $myScope.goToLink = goToLink;
        $myScope.sendResponse = sendResponse;


        Mensajes.showMessengerModal("screens/modals/messenger_modal.html", $myScope);
      }

      // modal scope
      var goToState = function(state) {
        $state.go(state);
        Mensajes.hideMessengerModal();
      }

      var cierraModal = function() {
        Mensajes.hideMessengerModal();
      }

      var goToLink = function(url) {
        if (window.cordova) {
          cordova.InAppBrowser.open(url, "_system");
        } else {
          window.open(url, '_blank', 'location=yes,height=570,width=520,scrollbars=yes,status=yes');
        }
        Mensajes.hideMessengerModal();
      }


      var sendResponse = function(action) {
        var actions = {
          action1: action == "action1"? true: false,
          action2: action == "action2"? true: false
        }

        MessengerFeedback.create(actions).then(function(data) {
          console.log("XXXXX",data);
          Mensajes.hideMessengerModal();
        }, function(error) {
          console.log("XXXXX",error);
        });

      }



      return {

        /*
        sendResponse:
        */

      }


    }
  );
