angular.module('siggo')
  .factory('$addVehicleModal', function ($rootScope, $ionicModal, $q, $filter, toaster, RequestFacade) {

    var _modal = null;
    var template = 'screens/modals/add-vehicle.html';
    var $scope = $rootScope.$new(true);
    $scope.data = {};
    var deferred = "";

    var show = function (state) {
      deferred = $q.defer();
      $scope.data = {};

      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false
      }).then(function (mod) {
        _modal = mod;
        _modal.show();
      });
      return deferred.promise;
    }

    var hide = function () {
      if (_modal) {
        _modal.remove()
          .then(function () {
            _modal = null;
          });
      }
    }

    var wait;

    $scope.verifyPlate = function () {
      clearInterval(wait);
      if ($scope.data.plate === undefined) return;
      $scope.data.plate = $filter('uppercase')($scope.data.plate);
      wait = setTimeout(function () {
        RequestFacade.index('vehicle', {
          type: 'plate',
          value: $scope.data.plate
        }).then(function (res) {
          $scope.data.plateAvailable = true;
        }, function (err) {
          $scope.error = true;
          $scope.data.plateAvailable = false;
          toaster.pop({
            body: 'La matrícula ya esta en uso',
            title: 'Error ' + err,
            type: 'error',
            tiemout: 5000
          });
        });
      }, 1000);
    }

    $scope.verifySerial = function () {
      clearInterval(wait);
      if ($scope.data.serial === undefined) return;
      $scope.data.serial = $filter('uppercase')($scope.data.serial);
      wait = setTimeout(function () {
        RequestFacade.index('vehicle', {
          type: 'serial',
          value: $scope.data.serial
        }).then(function (res) {
          $scope.data.serialAvailable = true;
        }, function (err) {
          $scope.error = true;
          $scope.data.serialAvailable = false;
          toaster.pop({
            body: 'El número de serie ya esta en uso',
            title: 'Error ' + err,
            type: 'error',
            tiemout: 5000
          });
        });
      }, 1000);
    }

    $scope.add = function () {
      var data = $scope.data;
      if (data.plate && data.serial && data.mark && data.model && data.year && data.color && data.plateAvailable && data.serialAvailable) {
        deferred.resolve(data);
        hide();
      }
    };

    $scope.close = hide;

    return {
      show: show,
      hide: hide
    }
  });