angular.module('siggo')
  .factory('$CitiesModal', function ($rootScope, $ionicModal, $q, RequestFacade) {

    var _modal = null;
    var template = 'screens/modals/cities.html';
    var $scope = $rootScope.$new(true);
    var dataset = [];
    var deferred = "";
    var state = "";

    var show = function (state) {
      deferred = $q.defer();
      state = state;
      RequestFacade.index('city', {
        state: state
      }).then(function (res) {
        $scope.dataset = res;
        console.log(res);
      });
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false
      }).then(function (mod) {
        _modal = mod;
        _modal.show();
      });
      return deferred.promise;
    }

    var hide = function () {
      if (_modal) {
        _modal.remove()
          .then(function () {
            _modal = null;
          });
      }
    }

    $scope.select = function (city) {
      deferred.resolve(city);
      hide();
    };


    $scope.close = hide;

    $scope.cierraModal = hide;

    return {
      show: show,
      hide: hide
    }
  })