angular.module('siggo')
  .factory('PanicButtonModal', function($rootScope, $ionicModal, $interval, Emergency) {

    var _modal = null;
    var template = 'screens/modals/panic-button.html';
    var $scope = $rootScope.$new(true);
    $scope.count = 10;


    var timer;
    var show = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      startTimer();
    }


    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
      $interval.cancel(timer);
    }


    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        _modal.show();
      });
    }


    var sendAlert = function() {
      Emergency.send().then(function(res) {
        hide();
        $rootScope.$broadcast("emergency_alarm_on");
      }, function(status) {
        setTimeout(sendRequestEmergency, 250);
      });
    }


    var startTimer = function(){
      $scope.count = 10;

      timer = $interval(function() {
          console.log('$interval timer panic-button');
        if ($scope.count == 0) {
          hide();
        }else{
          $scope.count--;
        }
      }, 1000);
    }


    // asign procedures to $scope modals
    $scope.close = hide;
    $scope.sendAlert = sendAlert;


    return {
      show: show,
      hide: hide
    }
  })
