angular.module('siggo')
  .factory('ServiceConfirmationModal', function($rootScope, $ionicModal, $log, $timeout, $cordovaMedia, deviceConfiguration, AccountPreferences) {

    var _modal = null;
    var template = 'screens/modals/confirmar-viaje.html';
    var $scope = $rootScope.$new(true);
    var dataset = [];
    var ciclo;
    // $scope.count = 10;


    // var timer;

    // me envia por compativilidad con versiones antiguas
    // data.Codigo;  // nonono
    // data.Descuento; // nonono

    var show = function(client) {
      $scope.Cliente = client;
      console.log(client);
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      // startTimer();
    }


    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            clearInterval(ciclo);
            _modal = null;
          });
      }
      // $interval.cancel(timer);
    }


    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        _modal.show();
        createSound();
        startTimer();
      });
    }

    var AceptarViaje = function() {
      $rootScope.$broadcast('serviceAccepted');
      hide();
    };
    var CancelarPeticion = function() {
      $rootScope.$broadcast('serviceRejected');
      hide();
    };


    var startTimer = function() {
      var x = 20;
      var porcentaje = 100;
      $scope.counterdown = porcentaje;
      ciclo = setInterval(function() {
        x--;
        console.log(x);
        porcentaje = (100 / 20) * x;
        console.log(porcentaje);
        $scope.counterdown = porcentaje;
        if (x % 3 == 0) requestSound();
        if (x <= 0) {
          $rootScope.$broadcast('serviceRejected');
          hide();
          console.log("terminar");
        }
      }, 1000);
    }

    var soundRequest = false;
    
    var createSound = () => {
      console.warn(deviceConfiguration.urlViaje);
      soundRequest = $cordovaMedia.newMedia(deviceConfiguration.urlViaje, () => {
        console.log("works");
      }, (r) => {
        console.error("do not work", r);
      });
      soundRequest.setVolume('1.0');
    }


    var requestSound = () => {
      console.log("soundRequest", soundRequest);
      if (soundRequest) soundRequest.play();
      var accessibility = AccountPreferences.localAccessibility();
      if (!accessibility) return;
      if (window.cordova && accessibility.deaf) {
        //$cordovaVibration.vibrate([300, 150, 300, 150, 1000]);
        //$$flashlight.flash([300, 150, 300, 150, 1000]);
        $cordovaVibration.vibrate(1500);
        $$flashlight.flash(1500);
      }
    }



    $scope.close = hide;

    $scope.cierraModal = hide;

    $scope.AceptarViaje = AceptarViaje;
    $scope.CancelarPeticion = CancelarPeticion;

    return {
      show: show,
      hide: hide
    }
  })
