angular.module('siggo')
  .factory('$StatesModal', function ($rootScope, $ionicModal, $q, RequestFacade) {

    var _modal = null;
    var template = 'screens/modals/states.html';
    var $scope = $rootScope.$new(true);
    var dataset = [];
    var deferred = "";

    var show = function () {
      deferred = $q.defer();
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false
      }).then(function (mod) {
        _modal = mod;
        _modal.show();
      });
      return deferred.promise;
    }

    var hide = function () {
      if (_modal) {
        _modal.remove()
          .then(function () {
            _modal = null;
          });
      }
    }

    $scope.select = function (state) {
      deferred.resolve(state);
      hide();
    };

    RequestFacade.index('state', {}).then(function (res) {
      $scope.dataset = res;
      console.log(res);
    });

    $scope.close = hide;

    $scope.cierraModal = hide;

    return {
      show: show,
      hide: hide
    }
  })