angular.module('siggo')
  .factory('TravelSummaryModal', function($rootScope, $ionicModal, $interval, Emergency,
    Socket, $log, Mensajes, $timeout) {

    var _modal = null;
    var template = 'screens/modals/travel-summary.html';
    var $scope = $rootScope.$new(true);
    // $scope.count = 10;


    // var timer;

    // me envia por compativilidad con versiones antiguas
    // data.Codigo;  // nonono
    // data.Descuento; // nonono

    var show = function(data) {
      console.log('TravelSummaryModal', data);
      $scope.viaje = data;
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      // startTimer();
    }


    var hide = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
      // $interval.cancel(timer);
    }


    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        $scope.viaje.Calificacion = 5;
        $scope.viaje.Comentarios = '';
        _modal.show();
      });
    }


    var calificarViaje = function() {
      $log.log('Inicio: $rootScope.CalificarViaje');

      Mensajes.showLoading("Enviando...");
      Socket.on("calificar_viaje", $scope.viajeCalificado);
      Socket.emit("calificar_viaje", {
        Calificacion: $scope.viaje.Calificacion,
        Comentarios: $scope.viaje.Comentarios,
        IdServicio: $scope.viaje.IdServicio
      });
    }

    var viajeCalificado = function(data) {
      console.log('.on calificar_viaje');

      Mensajes.hideLoading();
      hide();
      $timeout(function() {
        $rootScope.statusViaje = 0;
        //$rootScope.vehicleOnline = false;
      }, 5);
    }

    var cambiaCalificacion = function(val) {
      $scope.viaje.Calificacion = val;
      //$rootScope.Viaje.Calificacion = val; // afecta afuera quitarlo de aqui
    }


    /*
    var startTimer = function(){
      $scope.count = 10;

      timer = $interval(function() {
          console.log('$interval timer panic-button');
        if ($scope.count == 0) {
          hide();
        }else{
          $scope.count--;
        }
      }, 1000);
    }
    */


    // asign procedures to $scope modals
    $scope.close = hide;
    $scope.calificarViaje = calificarViaje;
    $scope.viajeCalificado = viajeCalificado;
    $scope.cambiaCalificacion = cambiaCalificacion;


    return {
      show: show,
      hide: hide
    }
  })
