angular.module('siggo')
  .factory('WaitClientConfirmationModal', function($rootScope, $ionicModal,
    $interval, Socket) {

    var _modal = null;
    var template = 'screens/modals/wait-client-confirmation.html';
    var $scope = $rootScope.$new(true);
    $scope.count = 25;


    var timer;
    var show = function() {
      if (_modal) {
        _modal.remove()
          .then(function() {
            _modal = null;
            createModal();
          });
      } else {
        createModal();
      }
      startTimer();
    }


    var hide = function() {
      if (_modal) {
        Socket.emit("conductor_estado_revisa");
        _modal.remove()
          .then(function() {
            _modal = null;
          });
      }
      $interval.cancel(timer);
    }


    var createModal = function() {
      $ionicModal.fromTemplateUrl(template, {
        scope: $scope,
        animation: 'slide-in-down',
        hardwareBackButtonClose: false
      }).then(function(mod) {
        _modal = mod;
        _modal.show();
      });
    }

    var startTimer = function(){
      $scope.count = 25;

      timer = $interval(function() {
        console.log('$interval timer wait-client-confirmation');
        if ($scope.count == 0) {
          hide();
        }else{
          $scope.count--;
        }
      }, 1000);
    }


    // asign procedures to $scope modals
    $scope.close = hide;


    return {
      show: show,
      hide: hide
    }
  })
