// https://www.npmjs.com/package/cordova-plugin-firebase

angular.module('siggo')
  .factory('PushManager', function ($ionicPlatform, deviceConfiguration, Push, $state, $cordovaMedia) {

    var getToken = function () {

      window.FirebasePlugin.getToken(function (token) {
        console.log('token', token)
        pushToken = token;
        console.log('pushToken', pushToken)
      }, function (error) {
        console.error(error);
        setTimeout(getToken, 250);
      });

      window.FirebasePlugin.getAPNSToken(function (apnsToken) {
        console.log(apnsToken);
      }, function (error) {
        console.error(error);
      });

    }


    var setChannels = function () {


      window.FirebasePlugin.createChannel({
        id: 'cancel_channel',
        description: 'Canal de cancelaciones',
        name: 'cancel_channel',
        sound: 'canelacion',
        vibration: true,
        light: true,
        importance: 4,
        badge: true,
        visibility: 1
      }, (success) => {
        console.log(success);
      }, (err) => {
        console.error(err);
      });

      const channel = {
        id: "my_default_channel",
        name: "My Default Name",
        description: "My Default Description",
        sound: "",
        vibration: [500, 200, 500],
        light: true,
        lightColor: "0xFF0000FF",
        importance: 4,
        badge: false,
        visibility: 1
      };

      window.FirebasePlugin.setDefaultChannel(channel,
        function () {
          console.log('Default channel set');
        },
        function (error) {
          console.log('Set default channel error: ' + error);
        });

    }

    var registra = function () {
      if (!pushToken) {
        setTimeout(registra, 250);
        return;
      }
      Push.update({
        token: pushToken,
        SO: deviceConfiguration.platform
      }).then(function (res) {
        console.log(res);
      }, function (status) {
        console.log(status);
      });
    }


    var configurar = function () {
      console.log('test');
      FirebasePlugin.onMessageReceived(function (notification) {
        console.log(notification);
        if ($state.name != 'app.inicio') $state.go('app.inicio');
        console.log(notification);
        if (notification.Sonido && deviceConfiguration.platform != "explorador") {
          var mediaPush;
          if (!mediaPush) {
            var audio = '/android_asset/www/audio/' + notification.Sonido + '.mp3';
            mediaPush = $cordovaMedia.newMedia(audio);
            console.log(mediaPush);
          }
          mediaPush.setVolume('1.0');
          mediaPush.play();
        }
      }, function (error) {
        console.error(error);
      });
    }

    /*
    var iosConfig = {
      "badge": true,
      "sound": true,
      "alert": true,
    };
    //477591987925
    var androidConfig = {
      "senderID": "901891709285",
    };
    */

    var pushToken;
    $ionicPlatform.ready(function () {
      console.log("tokenManager ready");
      if (deviceConfiguration.platform == "explorador") return;
      configurar();
      getToken();
      // setChannels();
    });


    return {
      registra: registra

    }
  })