angular.module('siggo')
  .service('RequestFacade', function ($q, $http, configuration, Usuario) {

    var request = {
      url: configuration.httpServices,
      data: {},
      headers: {
        'Content-Type': 'application/json'
      }
    };

    var index = function (url, data) {
      var _request = angular.copy(request);
      _request.method = "GET";
      _request.url += url;
      _request.params = data;
      _request.headers.accessToken = Usuario.getToken();
      return $http(_request).then(function (res) {
        if (typeof res.data === 'object') {
          return res.data;
        } else {
          return $q.reject(500);
        }
      }, function (err) {
        return $q.reject(err.status);
      });
    };

    var show = function (url, id) {
      var _request = angular.copy(request);
      _request.method = "GET";
      _request.url += url + "/" + id;
      _request.headers.accessToken = Usuario.getToken();
      return $http(_request).then(function (res) {
        if (typeof res.data === 'object') {
          return res.data;
        } else {
          return $q.reject(500);
        }
      }, function (err) {
        return $q.reject(err.status);
      });
    };

    var store = function (url, data) {
      var _request = angular.copy(request);
      _request.method = "POST";
      _request.url += url;
      _request.data = data;
      _request.headers.accessToken = Usuario.getToken();
      return $http(_request).then(function (res) {
        if (typeof res.data === 'object') {
          return res.data;
        } else {
          return $q.reject(500);
        }
      }, function (err) {
        return $q.reject(err.status);
      });
    };

    var update = function (url, id, data) {
      var _request = angular.copy(request);
      _request.method = "PUT";
      _request.url += url + "/" + id;
      _request.data = data;
      _request.headers.accessToken = Usuario.getToken();
      return $http(_request).then(function (res) {
        if (typeof res.data === 'object') {
          return res.data;
        } else {
          return $q.reject(500);
        }
      }, function (err) {
        return $q.reject(err.status);
      });
    };

    var remove = function (url, id) {
      var _request = angular.copy(request);
      _request.method = "DELETE";
      _request.url += url + "/" + id;
      _request.headers.accessToken = Usuario.getToken();
      return $http(_request).then(function (res) {
        if (typeof res.data === 'object') {
          return res.data;
        } else {
          return $q.reject(500);
        }
      }, function (err) {
        return $q.reject(err.status);
      });
    };

    return {
      index: index,
      show: show,
      store: store,
      update: update,
      remove: remove
    }

  });