"use strict";

angular.module('siggo')
    .factory('AccountStatement', function($http, $q, $rootScope, configuration) {


        var post = {
            method: 'POST',
            url: configuration.http.getUrl() + "account-statement",
            headers: {
                'Content-Type': 'application/json'
            },
            data: { },
            timeout: 15000
        };


        var _debit;
        var _full;
        var _lastId;




        var getDebit = function () {
          var _post = angular.copy(post);
          //_post.url += "incomes/period";
          _post.data = {filter: 'debit'};
          _post.headers.accessToken = $rootScope.Usuario.Token;

          return $http(_post)
            .then(function(res){
                //console.log(res);
              if (typeof res.data === 'object'){
                _debit = res.data;
                return res.data;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) { console.log(err); }
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin
              console.info(err);
              return $q.reject(err.status);
            });

        };

        var getPeriods = function () {
          var _post = angular.copy(post);
          //_post.url += "incomes/period";
          _post.data = {start: _lastId, limit: 10};
          _post.headers.accessToken = $rootScope.Usuario.Token;

          return $http(_post)
            .then(function(res){
                //console.log(res);
              if (typeof res.data === 'object'){
                if (res.data.history.length==0){
                  $rootScope.$broadcast('scroll.account-statement-history.nomore');
                  return _full;
                }

                if (!_full) {
                  _full = res.data;

                  setLastId(_full.history);
                  return _full;
                }


                for(var id in res.data.history) {
                  _full.history.push(res.data.history[id]);
                }

                setLastId(_full.history);
                return _full;

              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) { console.log(err); }
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin
              console.info(err);
              return $q.reject(err.status);
            });

        };


        var setLastId = function (arr) {
          var n = arr.length;
          _lastId = arr[n-1].periodo;
        };



        var getSummary = function (period) {
          var _post = angular.copy(post);
          _post.url += "/summary";
          _post.data = {period: period};
          _post.headers.accessToken = $rootScope.Usuario.Token;

          return $http(_post)
            .then(function(res){
                //console.log(res);
              if (typeof res.data === 'object'){
                _debit = res.data;
                return res.data;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) { console.log(err); }
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin
              console.info(err);
              return $q.reject(err.status);
            });

        };




        return {
            getPeriods: getPeriods,
            getDebit: getDebit,
            getSummary: getSummary
        };
    })
