angular.module('siggo')
    .factory('News', function(localStorageService, $q, $http, $rootScope, Socket, configuration) {

        var post = {
            method: 'POST',
            url: configuration.http.getUrl()+"news/driver/",
            headers: {
                'Content-Type': 'application/json',
                accessToken: ""
            },
            data: { },
            timeout: 15000
        }




        var _news = localStorageService.get("news") || [];



        var getNews = function() {
            var _post = angular.copy(post);
            _post.url += "get/new";
            //_post.data = requestConfiguration;
            //_post.headers.accessToken = Usuario.get().Token;
            _post.headers.accessToken = localStorageService.get("Usuario").Token;


            return $http(_post)
            .then(function(res){
              //console.log(res);
              if (typeof res.data === 'object'){


                for (var id in res.data) {
                    var obj = angular.extend(res.data[id], {newViewed: false});
                    _news.push( obj );
                }

                //angular.extend(_news, res.data);
                //_news.extend(res);

                localStorageService.set("news", _news);
                $rootScope.$broadcast('count_news');


                return _news;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) console.log(err);
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin

              console.info(err);
              return $q.reject(err.status);
            });
        }



        var getLocalNews = function(){
            return _news;
        }

        var noUnreadNews = function(){
            var no = 0;

            for (var id in _news) {
                if (_news[id].newViewed == false) no++;
            }

            return no;
        }

        var newsReaded = function(){
            for (var id in _news) {
                _news[id].newViewed = true;
            }
            localStorageService.set("news", _news);
            $rootScope.$broadcast('count_news');

        }

        var deleteNew = function(item){
            var index = _news.indexOf(item);
            _news.splice(index, 1);
            localStorageService.set("news", _news);
        }


        var startObserver = function() {
            Socket.off('news_update');
            Socket.on('news_update', function() {
              console.log('.on news_update');
                //to test
                getNews();
                Socket.emit('news_update_received');
            });
        }



        return {
            /*add: addNew,*/
            getNews: getNews,
            getLocalNews: getLocalNews,
            noUnreadNews: noUnreadNews,
            newsReaded: newsReaded,
            news: _news,
            deleteNew: deleteNew,
            startObserver: startObserver
        }



    });
