angular.module('siggo')
  .factory('Push', function (localStorageService, $q, $http, $rootScope, Socket, configuration) {

    var request = {
      method: '',
      url: configuration.http.getUrl() + "push/driver",
      headers: {
        'Content-Type': 'application/json',
        accessToken: ""
      },
      data: {},
      timeout: 15000
    }



    var put = function (data) {
      var _request = angular.copy(request);
      _request.method += "PUT";
      if (!localStorageService.get("Usuario")) return $q.reject('token_undefined');
      _request.headers.accessToken = localStorageService.get("Usuario").Token;
      _request.data = data;

      return $http(_request)
        .then(function (res) {
          if (typeof res.data === 'object') {

            return res.data;
          } else {
            return $q.reject(500);
          }
        }, function (err) {
          if (err.status == 511) console.log(err);
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin

          console.info(err);
          return $q.reject(err.status);
        });
    }


    return {
      update: put
    }


  });