angular.module('siggo')
    .factory('Requirements', function($rootScope, $http, $q, localStorageService, Socket, configuration) {


        var post = {
            method: 'POST',
            url: configuration.http.getUrl()+"requirements/driver/",
            headers: {
                'Content-Type': 'application/json',
                accessToken: ""
            },
            data: { },
            timeout: 15000
        }

        var _requirements = [];


        /* ONLY FOR TESTING - DELETE */
        /*
        var _requirements = [
            {id: 1, title: "Credencial 1", description: "Sube tu credencial es obligatorio"},
            {id: 2, title: "Credencial 2", description: "Sube tu credencial es obligatorio"},
            {id: 3, title: "Credencial 3", description: "Sube tu credencial es obligatorio"},
        ];
        */

        var getRequirements = function() {
            var _post = angular.copy(post);
            _post.url += "get/all";
            //_post.data = requestConfiguration;
            //_post.headers.accessToken = Usuario.get().Token;
            _post.headers.accessToken = localStorageService.get("Usuario").Token;

            return $http(_post)
            .then(function(res){
              //console.log(res);
              if (typeof res.data === 'object'){
                _requirements = res.data;

                $rootScope.$broadcast('requirements_updated');

                return _requirements;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) console.log(err);
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin

              console.info(err);
              return $q.reject(err.status);
            });
        }


        var uploadPicture = function(requirement){
            var _post = angular.copy(post);
            _post.url += "upload/file";
            _post.data = requirement;
            //_post.headers.accessToken = Usuario.get().Token;
            _post.headers.accessToken = localStorageService.get("Usuario").Token;

            return $http(_post)
            .then(function(res){
              //console.log(res);
              if (typeof res.data === 'object'){

                removeRequirement(requirement.id);

                $rootScope.$broadcast('requirements_updated');

                return res;
              }else{
                return $q.reject(500);
              }
            },function(err){
              if (err.status == 511) console.log(err);
              // crear directiva para cuando no está autorizado o redireccionar a loguin ???
              // me agradaria servicio que pase como parametro la ruta actual a loguin

              console.info(err);
              return $q.reject(err.status);
            });

        }


        var removeRequirement = function(id) {
            for (req in _requirements){
                if (_requirements[req].id == id){
                    _requirements.splice(req, 1);
                    return;
                }

            }
        }


        var noUnreadNews = function(){
            var no = 0;

            for (var id in _news) {
                if (_news[id].newViewed == false) no++;
            }

            return no;
        }



        var noRequirements = function() {
            var no = 0;
            no = _requirements.length;
            if(no > 0)return $q.resolve(no);
            return $q.reject();
        }



        var startObserver = function() {
            Socket.off('requirements_update');
            Socket.on('requirements_update', function() {
              console.log('.on requirements_update');
                //to test
                getRequirements();
                Socket.emit('requirements_update_received');
            });
        }





        return {
            noRequirements: noRequirements,
            getRequirements: getRequirements,
            requirements: _requirements,
            getLocalRequirements: function(){
                return _requirements;
            },
            uploadPicture: uploadPicture,
            startObserver: startObserver
        };
    })
