angular.module('siggo')
  .factory('UserPreferences', function($q, $http, $rootScope, Usuario, configuration, localStorageService) {

    var request = {
      url: configuration.http.getUrl() + "client/preferences",
      headers: {
        'Content-Type': 'application/json',
        accessToken: ""
      },
      data: {},
      timeout: 15000
    }


    var _preferences = localStorageService.get("user-preferences") || {};

    var get = function(dataRequest) {
      var _request = angular.copy(request);
      _request.method = "GET";
      _request.headers.accessToken = Usuario.get().Token;

      return $http(_request)
        .then(function(res) {
          //console.log(res);
          if (typeof res.data === 'object') {

            localStorageService.set("user-preferences", res.data);

            return res.data;
          } else {
            return $q.reject(500);
          }
        }, function(err) {
          if (err.status == 511) console.log(err);
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin

          console.info(err);
          return $q.reject(err.status);
        });
    }




    // thie method will be sended eevery time whe has a change or in a lapse time ????
    // I think is better a laps time
    var put = function(dataRequest) {
      var _request = angular.copy(request);
      _request.method = "PUT";
      _request.data = dataRequest;
      _request.headers.accessToken = Usuario.get().Token;

      return $http(_request)
        .then(function(res) {
          //console.log(res);
          if (typeof res.data === 'object') {
            putLocal(dataRequest);

            return res.data;
          } else {
            return $q.reject(500);
          }
        }, function(err) {
          if (err.status == 511) console.log(err);
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin

          console.info(err);
          return $q.reject(err.status);
        });
    }



    var getLocal = function() {
      return localStorageService.get("user-preferences");
    }


    var putLocal = function(data) {
      //var preferences =  localStorageService.get("user-preferences");
      var preferences = angular.extend(localStorageService.get("user-preferences"), data);
      console.log(preferences);
      localStorageService.set("user-preferences", preferences);
    }


    return {
      read: get,
      readLocal: getLocal,
      //create: post,
      update: put
      //delete: delete
    }



  });
