angular.module('siggo')
.factory('User', function ($http, $q, $rootScope, configuration) {

    var post = {
        method: 'POST',
        url: configuration.http.getUrl()+"user/",
        headers: {
            'Content-Type': 'application/json'
        },
        data: { },
        timeout: 15000
    };


    var _user;




    var getInfo = function (period) {
      var _post = angular.copy(post);
      _post.url += "get-info";
      //_post.data = {period: period};
      _post.headers.accessToken = $rootScope.Usuario.Token;
      return $http(_post)
        .then(function(res){
            console.log(res);
          if (typeof res.data === 'object'){
            _user = res.data;
            return res.data;
          }else{
            return $q.reject(500);
          }
        },function(err){
          if (err.status == 511) { console.log(err); }
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin
          console.info(err);
          return $q.reject(err.status);
        });

    };


    var connectVehicle = function (idVehicle, idCategory) {
      var _post = angular.copy(post);
      _post.url += "vehicle/connect";
      _post.data = {IdVehiculo: idVehicle, IdCategoria: idCategory};
      _post.headers.accessToken = $rootScope.Usuario.Token;

      return $http(_post)
        .then(function(res){
            //console.log(res);
          if (typeof res.data === 'object'){
            _user = res.data;
            return res.data;
          }else{
            return $q.reject(500);
          }
        },function(err){
          if (err.status == 511) { console.log(err); }
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin
          console.info(err);
          return $q.reject(err.status);
        });

    };

    var disconnectVehicle = function () {
      var _post = angular.copy(post);
      _post.url += "vehicle/disconnect";
      //_post.data = {IdVehiculo: idVehicle, IdCategoria: idCategory};
      _post.headers.accessToken = $rootScope.Usuario.Token;

      return $http(_post)
        .then(function(res){
            //console.log(res);
          if (typeof res.data === 'object'){
            _user = res.data;
            return res.data;
          }else{
            return $q.reject(500);
          }
        },function(err){
          if (err.status == 511) { console.log(err); }
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin
          console.info(err);
          return $q.reject(err.status);
        });

    };




    var getVehiclesList = function () {
      var _post = angular.copy(post);
      _post.method = "GET";
      _post.url += "vehicles";
      //_post.data = {IdVehiculo: idVehicle, IdCategoria: idCategory};
      _post.headers.accessToken = $rootScope.Usuario.Token;

      return $http(_post)
        .then(function(res){
            console.log("User getVehiclesList",res);
          if (typeof res.data === 'object'){
            _user = res.data;
            return res.data;
          }else{
            return $q.reject(500);
          }
        },function(err){
          if (err.status == 511) { console.log(err); }
          // crear directiva para cuando no está autorizado o redireccionar a loguin ???
          // me agradaria servicio que pase como parametro la ruta actual a loguin
          console.info(err);
          return $q.reject(err.status);
        });

    };





    return {
        getInfo: getInfo,
        connectVehicle: connectVehicle,
        disconnectVehicle: disconnectVehicle,
        getVehiclesList: getVehiclesList
    };

})
