angular.module('siggo')
  .factory('Socket', function($rootScope, configuration) {
    //console.log('Socket');


    var socket = null;
    var isConected = false;
    var timeWaitConnection = 10000;
    var timeoutsDisconnection = [];

    var initialize = function(token) {
      if (!token) {
        return false;
      }

      if (socket) {
        socket.removeAllListeners();
        socket.disconnect();
      }

      socket = null;


      socket = io.connect(configuration.Socket.getUrl(), {
        reconnection: true,
        query: "token=" + token,
        "force new connection": true
        /*,
                        transports: ['websocket'],
                        upgrade: false*/
      });



      //socket.on("autenticated", function(val) {})
      //socket.on("unauthorized", function(val) {})

      socket.on("connect", function() {
        isConected = true;

        // limpia timeouts de desconexion
        for (var i = 0; i < timeoutsDisconnection.length; i++) {
          clearTimeout(timeoutsDisconnection[i]);
        }
        timeoutsDisconnection = [];

        //avisa a rootScope de conexion
        $rootScope.conexion = true;
        $rootScope.$broadcast("socket.connect", true);


        $rootScope.$broadcast("socket_connected");

      })

      socket.on("connect_error", function() {
        isConected = false;

        // establece timeout para esperar conexion antes de informar
        timeoutsDisconnection.push(
          setTimeout(function() {
            $rootScope.conexion = false;
          }, timeWaitConnection)
        );
      })

      socket.on("reconnect", function() {
        //console.info("reconnect");
      })

      socket.on("reconnect_error", function() {
        isConected = false;

        // establece timeout para esperar conexion antes de informar
        timeoutsDisconnection.push(
          setTimeout(function() {
            $rootScope.conexion = false;
          }, timeWaitConnection)
        );
      })

      socket.on("disconnect", function() {
        isConected = false;

        // establece timeout para esperar conexion antes de informar
        timeoutsDisconnection.push(
          setTimeout(function() {
            $rootScope.conexion = false;
          }, timeWaitConnection)
        );
      })

      // no afecta conneccion
      socket.on("error", function(error) {
        isConected = false;

        // establece timeout para esperar conexion antes de informar
        timeoutsDisconnection.push(
          setTimeout(function() {
            $rootScope.conexion = false;
          }, timeWaitConnection)
        );
      })

      return socket;
    }

    return {
      open: function(token) {
        return initialize(token);
      },
      connect: function() {
        // old
        //if (!conectado) socket.connect();
        socket.connect();
        return true;
      },
      disconnect: function() {
        if (socket) {
          socket.disconnect();
        }
      },
      emit: function(event, data) {
        try {
          data = (data == null) ? {} : data;
          if (socket) socket.emit(event, data);
        } catch (err) {
          console.error('Socket: emit error ->' + err);
        }
      },
      on: function(event, funcion) {
        if (socket) {
          socket.off(event);
          socket.on(event, funcion);
        }
      },
      off: function(event, funcion) {
        if (socket) socket.removeListener(event, funcion);
      },
      status: function() {
        if (!socket) return false;
        return socket.connected;
      },
      close: function() {
        if (socket) {
          socket.removeAllListeners();
          socket.disconnect();
        }
      }
    };
  })
