angular.module('siggo')
  .factory('Usuario', function usuarioFactory($rootScope, $http, localStorageService, $q,
    configuration) {

    var myUser = null;

    var getUser = function () {
      myUser = localStorageService.get("Usuario");
      return myUser;
    }

    var setUser = function (user) {
      myUser = user;
      localStorageService.set("Usuario", myUser);

      if (!user) return;

      myUser.picture = '';
      localStorageService.set("Usuario", myUser);
    }

    var getToken = function () {
      if (localStorageService.get("Usuario")) return localStorageService.get("Usuario").Token;
      else return "";
    };

    var getAvatar = function () {
      return $http({
          method: 'Get',
          url: configuration.http.getUrl() + "avatar/" + localStorageService.get("Usuario").Id,
          timeout: 15000
        })
        .then(function (res) {
            console.log(res);
            if (typeof res.data === 'object') {
              return res.data;
            } else {
              return $q.reject(500);
            }
          },
          function (err) {
            console.info(err);
            return $q.reject(err.status);
          });
    }



    var setAvatar = function (picture) {
      //if (!picture) return $q.reject();
      var data = {
        id: localStorageService.get("Usuario").Id,
        picture: picture
      };



      return $http({
          method: 'Post',
          url: configuration.http.getUrl() + "avatar",
          data: data,
          timeout: 15000
        })
        .then(function (res) {
            console.log(res);
            if (typeof res.data === 'object') {
              return res.data;
            } else {
              return $q.reject(500);
            }
          },
          function (err) {
            console.info(err);
            return $q.reject(err.status);
          });
    }


    return {
      get: getUser,
      set: setUser,
      getAvatar: getAvatar,
      setAvatar: setAvatar,
      getToken: getToken
    };
  })